# Latest commit on Dec 20 2015: 5ad7cd5 - preparing tarball:
# git clone https://github.com/lwfinger/rtl8723bu.git -b v4.3.16
# rtl8723BU_WiFi_linux_v4.3.9.3_13200.20150106_BTCOEX20140929-5443
# git archive 

%global	module	8723bu
%global pname rtl%{module}
%define nocname	%{pname}-noc

Name:		dkms-%{pname}
Version:	4.3.16
Release:	%mkrel 2
Source0:	%{pname}-%{version}.tar.xz
Patch0:		rtl8723bu-v4.3.9.3-Makefile.patch

License:	GPLv2
Group:		System/Kernel and hardware
URL:		https://github.com/lwfinger/rtl8723bu
Summary:	dkms package for realtek 8723bu driver
BuildRoot:	%{_tmppath}/%{name}-%{version}-buildroot

Provides:	%{name}-%{version}
Provides:	kmod(%{module}.ko) = %{version}
Requires(post):		dkms
Requires(preun):	dkms
Conflicts:	dkms-%{nocname}
Obsoletes:	dkms-%{pname} < %{version}-%{release}

%description
Driver for Realtek RTL8723BU Wireless Adapter with Hardware ID 0bda:b720
802.11bgn USB 2.0 WLAN with Bluetooth 4.0 Single-Chip Controller
+++
By default driver operates the hardware as a station AND as an access point *simultaneously*.
This will show two devices when you run the `iwconfig` command.
If you do not want two devices (station and an access point) *simultaneously*,
then install the rpm dkms-%{nocname}.
+++
The Realtek RTL8723BU is an 802.11bgn 2.4G single-chip that integrates Wireless LAN (WLAN)
and a network USB interface (USB 1.0/1.1/2.0 compatible) controller with
integrated Bluetooth 2.1/3.0/4.0 controller.
It combines a WLAN MAC, a 1T1R capable WLAN baseband, and WLAN RF in a single chip.
The RTL8723BU provides a complete solution for a high-throughput performance and
low power consumption integrated wireless LAN device. 
Features:
    56-pin QFN
    802.11bgn
    USB 2.0 for WLAN and Bluetooth
    Embedded Balun
    Wake on Wireless LAN
    Antenna Diversity
    Bluetooth Low Energy


%prep
%setup -qn %{pname}-%{version}
find -type f -exec chmod 0644 {} \;
%apply_patches

%install
%__rm -rf %{buildroot}
%__install -dm755 %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}
%__install -dm755 %{buildroot}/lib/firmware/rtlwifi
%__install -dm755 %{buildroot}/lib/firmware/rtl_bt
%__cp -a ./* %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}
%__mv %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}/rtl8723bu_bt.bin %{buildroot}/lib/firmware/rtl_bt/
%__cp -a %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}/rtl8723bu*.bin %{buildroot}/lib/firmware/rtlwifi/

%__rm -f %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}/{CONTRIBUTORS.md,LICENSE,README.md}

%__cat <<EOF > %{buildroot}%{_usrsrc}/%{pname}-%{version}-%{release}/dkms.conf
PACKAGE_NAME="%{pname}"
PACKAGE_VERSION="%{version}-%{release}"
BUILT_MODULE_NAME[0]="%{module}"
DEST_MODULE_LOCATION[0]="/kernel/3rdparty/%{pname}"
MAKE[0]="'make' SKIP_STACK_VALIDATION=1"
AUTOINSTALL="yes"
CLEAN="make clean"
EOF

%post -n %{name}
/usr/sbin/dkms --rpm_safe_upgrade add -m %{pname} -v %{version}-%{release}
/usr/sbin/dkms --rpm_safe_upgrade build -m %{pname} -v %{version}-%{release}
/usr/sbin/dkms --rpm_safe_upgrade install -m %{pname} -v %{version}-%{release}

if [ "$1" = 1 ]; then
/sbin/rmmod rtl8xxxu > /dev/null 2>&1
echo "rtl8xxxu" >> /etc/modprobe.d/blacklist 2>&1
echo "blacklist rtl8xxxu" > /etc/modprobe.d/%{pname}.conf 2>&1
/sbin/modprobe %{module} > /dev/null 2>&1
echo "Reloading network configuration ... "
/sbin/service network reload > /dev/null 2>&1
echo "%{module}" >> /etc/modprobe.preload 2>&1
fi

%preun -n %{name}
/usr/sbin/dkms --rpm_safe_upgrade remove -m %{pname} -v %{version}-%{release} --all

if [ "$1" = 0 ]; then
/sbin/rmmod %{module} > /dev/null 2>&1
sed -i '/rtl8xxxu/ d' /etc/modprobe.d/blacklist 2>&1
sed -i '/%{module}/ d' /etc/modprobe.preload 2>&1
echo "Reloading network configuration ... "
/sbin/service network reload > /dev/null 2>&1
fi

%postun
if [ ! -f /lib/modules/*/kernel/3rdparty/rtl8723bu/* ]; then
rm -rf /lib/modules/*/kernel/3rdparty/rtl8723bu 2>&1
fi

%clean
%__rm -rf %{buildroot}

%files
%defattr(-,root,root)
%doc README.md
%{_usrsrc}/%{pname}-%{version}-%{release}
%config(noreplace) /lib/firmware/rtlwifi/rtl8723bu_ap_wowlan.bin
%config(noreplace) /lib/firmware/rtlwifi/rtl8723bu_nic.bin
%config(noreplace) /lib/firmware/rtlwifi/rtl8723bu_wowlan.bin
%config(noreplace) /lib/firmware/rtl_bt/rtl8723bu_bt.bin


%changelog
* Mon Sep 07 2020 onkelho <oh.quait at gmail.com> - 4.3.16-2pclos2020
- rebuild, 

* Thu Aug 20 2020 onkelho <oh.quait at gmail.com> - 4.3.16-1pclos2020
- new version 4.3.16

* Thu Apr 09 2020 onkelho <oh.quait at gmail.com> - 4.3.9.3-7pclos2020
- new version 4.3.16

* Mon Jul 15 2019 onkelho <oh.quait at gmail.com> 4.3.9.3-6pclos2018
- rebuild fix linux5.2

* Mon May 13 2019 onkelho <oh.quait at gmail.com> 4.3.9.3-5pclos2019
- rebuild - linux-5.1.1
- add patch0 so we can get full git pull

* Mon Mar 11 2019 onkelho <oh.quait at gmail.com> 4.3.9.3-4pclos2019
- rebuild fix kernel-5.0

* Sat Oct 27 2018 onkelho <oh.quait at gmail.com> 4.3.9.3-3pclos2018
- build two packages in on step
- update source
- - lwfinger rtl8723bu: Fix builds on kernels through 4.20
- - Latest commit 56650f7 22 hours ago 
- change modules destdirectory to /3rdparty/

* Tue Mar 01 2018 onkelho <oh.quait at gmail.com> 4.3.9.3-2pclos2018
- fix for API changes on 4.15...
- rtl8723BU_WiFi_linux_v4.3.9.3_13200.20150106_BTCOEX20140929-5443

* Sun Nov 04 2017 onkelho <oh.quait at gmail.com> 4.3.9.3-1pclos2017
- new build --update from Oct22-2017

* Mon Mar 13 2017 onkelho <oh.quait at gmail.com> 1.0-3pclos2017 
-  rtl8723bu: Fix build for kernel 4.11 API changes

* Tue Feb 28 2017 onkelho <oh.quait at gmail.com> 1.0-2pclos2017
- updates from 26022017-master

* Sun Nov 27 2016 onkelho <oh.quait at t-online.de> 1.0-1pclos2016
- Initial build for PCLinuxOS

